JUCE: XmlDocument Class Reference

JUCE

Public Member Functions | Static Public Member Functions | List of all members
XmlDocument Class Reference

Parses a text-based XML document and creates an XmlElement object from it. More...

## Public Member Functions
| XmlDocument (const String &documentText)
| Creates an XmlDocument from the xml text. More...
| XmlDocument (const File &file)
| Creates an XmlDocument from a file. More...
| ~XmlDocument ()
| Destructor. More...
std::unique_ptr< XmlElement > | getDocumentElement (bool onlyReadOuterDocumentElement=false)
| Creates an XmlElement object to represent the main document node. More...
std::unique_ptr< XmlElement > | getDocumentElementIfTagMatches (StringRef requiredTag)
| Does an inexpensive check to see whether the outer element has the given tag name, and then does a full parse if it matches. More...
const String & | getLastParseError () const noexcept
| Returns the parsing error that occurred the last time getDocumentElement was called. More...
void | setInputSource (InputSource *newSource) noexcept
| Sets an input source object to use for parsing documents that reference external entities. More...
void | setEmptyTextElementsIgnored (bool shouldBeIgnored) noexcept
| Sets a flag to change the treatment of empty text elements. More...

## Static Public Member Functions
static std::unique_ptr< XmlElement > | parse (const File &file)
| A handy static method that parses a file. More...
static std::unique_ptr< XmlElement > | parse (const String &xmlData)
| A handy static method that parses some XML data. More...

## Detailed Description

Parses a text-based XML document and creates an XmlElement object from it.

The parser will parse DTDs to load external entities but won't check the document for validity against the DTD.

e.g.

XmlDocument myDocument (File ("myfile.xml"));
if (auto mainElement = myDocument.getDocumentElement())
{
..use the element
}
else
{
String error = myDocument.getLastParseError();
}

Or you can use the helper functions for much less verbose parsing..

if (auto xml = parseXML (myXmlFile))
{
if (xml->hasTagName ("foobar"))
{
...etc
}
}

See also
  XmlElement

## Constructor & Destructor Documentation

## ◆ XmlDocument() [1/2]

XmlDocument::XmlDocument | ( | const String & | documentText | ) |

Creates an XmlDocument from the xml text.

The text doesn't actually get parsed until the getDocumentElement() method is called.

## ◆ XmlDocument() [2/2]

XmlDocument::XmlDocument | ( | const File & | file | ) |

Creates an XmlDocument from a file.

The text doesn't actually get parsed until the getDocumentElement() method is called.

## ◆ ~XmlDocument()

XmlDocument::~XmlDocument | ( |  | ) |

Destructor.

## Member Function Documentation

## ◆ getDocumentElement()

std::unique_ptr<XmlElement> XmlDocument::getDocumentElement | ( | bool | onlyReadOuterDocumentElement = `false` | ) |

Creates an XmlElement object to represent the main document node.

This method will do the actual parsing of the text, and if there's a parse error, it may returns nullptr (and you can find out the error using the getLastParseError() method).

See also the parse() methods, which provide a shorthand way to quickly parse a file or string.

Parameters

  onlyReadOuterDocumentElement | if true, the parser will only read the first section of the file, and will only return the outer document element - this allows quick checking of large files to see if they contain the correct type of tag, without having to parse the entire file

Returns
  a new XmlElement which the caller will need to delete, or null if there was an error.

See also
  getLastParseError, getDocumentElementIfTagMatches

## ◆ getDocumentElementIfTagMatches()

std::unique_ptr<XmlElement> XmlDocument::getDocumentElementIfTagMatches | ( | StringRef | requiredTag | ) |

Does an inexpensive check to see whether the outer element has the given tag name, and then does a full parse if it matches.

If the tag is different, or the XML parse fails, this will return nullptr.

## ◆ getLastParseError()

const String& XmlDocument::getLastParseError | ( |  | ) | const
| noexcept

Returns the parsing error that occurred the last time getDocumentElement was called.

Returns
  the error, or an empty string if there was no error.

## ◆ setInputSource()

void XmlDocument::setInputSource | ( | InputSource * | newSource | ) |
| noexcept

Sets an input source object to use for parsing documents that reference external entities.

If the document has been created from a file, this probably won't be needed, but if you're parsing some text and there might be a DTD that references external files, you may need to create a custom input source that can retrieve the other files it needs.

The object that is passed-in will be deleted automatically when no longer needed.

See also
  InputSource

## ◆ setEmptyTextElementsIgnored()

void XmlDocument::setEmptyTextElementsIgnored | ( | bool | shouldBeIgnored | ) |
| noexcept

Sets a flag to change the treatment of empty text elements.

If this is true (the default state), then any text elements that contain only whitespace characters will be ingored during parsing. If you need to catch whitespace-only text, then you should set this to false before calling the getDocumentElement() method.

## ◆ parse() [1/2]

static std::unique_ptr<XmlElement> XmlDocument::parse | ( | const File & | file | ) |
| static

A handy static method that parses a file.

This is a shortcut for creating an XmlDocument object and calling getDocumentElement() on it. An even better shortcut is the juce::parseXML() function, which returns a std::unique_ptr<XmlElement>!

Returns
  a new XmlElement which the caller will need to delete, or null if there was an error.

## ◆ parse() [2/2]

static std::unique_ptr<XmlElement> XmlDocument::parse | ( | const String & | xmlData | ) |
| static

A handy static method that parses some XML data.

This is a shortcut for creating an XmlDocument object and calling getDocumentElement() on it. An even better shortcut is the juce::parseXML() function, which returns a std::unique_ptr<XmlElement>!

Returns
  a new XmlElement which the caller will need to delete, or null if there was an error.

The documentation for this class was generated from the following file:

- juce_XmlDocument.h

parseXML
std::unique_ptr< XmlElement > parseXML(const String &textToParse)
Attempts to parse some XML text, returning a new XmlElement if it was valid.
String
The JUCE String class!
Definition: juce_String.h:39
File
Represents a local file or directory.
Definition: juce_File.h:41
XmlDocument
Parses a text-based XML document and creates an XmlElement object from it.
Definition: juce_XmlDocument.h:64